var FileVersion = "1000";
var AssemblyVersion = "1.0.0.0";
var gadgetWidth;
var gadgetHeight;
var strBackground = 'default';
var strTextColor = 'white';
var bChangingSpeed = false;
var HelperControl;
var bIndexerPaused = false;
var bIndexerDisabled = false;
var bIndexNowPushed = false;
var bSupportsIndexNow = false;
var bIsElevated = false;
var fadeInterval;
var updateInterval;

////////////////////////////////////////////////////////////////////////////////
// How this Gadget works:
// The StatusHelper is a .NET control hosted via ActiveX.  It is registered by the PreLoad() function
// PreLoad() is called directly in the SearchGadget.html file, BEFORE it attempts to load the .NET control.
// This Javascript file controls the layout and appearence of the gadget itself
////////////////////////////////////////////////////////////////////////////////

// Preload is called by the HTML file BEFORE it loads the .NET control.
function PreLoad()
{
    // For some reason, this must be registered in HKLM if UAC is *DISABLED*.
    // If UAC is enabled, we can't write to HKLM but HKCU works.  
    try
    {
        regAsm("HKLM", "IndexerGadgetHelper.StatusHelper", "IndexerGadgetHelper.StatusHelper", "{7116EF10-DE66-4175-8790-97209D720A03}", "IndexerGadgetHelper, Version=" + AssemblyVersion + ", Culture=neutral, PublicKeyToken=null", AssemblyVersion, System.Gadget.path + "\\bin\\IndexerGadgetHelper" + FileVersion + ".dll");
        bIsElevated = true;
    }
    catch(e)
    {
        regAsm("HKCU", "IndexerGadgetHelper.StatusHelper", "IndexerGadgetHelper.StatusHelper", "{7116EF10-DE66-4175-8790-97209D720A03}", "IndexerGadgetHelper, Version=" + AssemblyVersion + ", Culture=neutral, PublicKeyToken=null", AssemblyVersion, System.Gadget.path + "\\bin\\IndexerGadgetHelper" + FileVersion + ".dll");
    }
}


////////////////////////////////////////////////////////////////////////////////

// When the HTML document has completed loading we setup our events, then initialize the Indexer APIs
// which we will use later.  Then we refresh any persisted settings which triggers an update of the layout
// and starts our main loop (the "update()" function).
window.onload = function()
{    
    try
    {
        divPendingUrlCount.innerText = "Loading...";
        HelperControl = new ActiveXObject("IndexerGadgetHelper.StatusHelper");
        var objVersion = HelperControl.GetGadgetVersion();
        if(objVersion != FileVersion)
        {
            divPendingUrlCount.innerText = "Restart Sidebar!";
        }
    }
    catch(e)
    {
        divPendingUrlCount.innerText = "Error!";
        // This means that the control failed to load.  This could happen for a number of reasons, including some failure during registration,
        // a problem loading .NET, or a crash of some kind.  In such an event, we want the rest of the gadget to still work normally.
    }
    
    // Setup events
    System.Gadget.onSettingsClosed = refreshSettings;
    //System.Gadget.onUndock = refreshSettings;
    //System.Gadget.onDock = refreshSettings;
    imgOptions.onclick = RunCPL;
    imgPause.onclick = PauseIndexing;
    imgPlay.onclick = IndexNormal;
    imgFastForward.onclick = IndexFast;
    
    // Settings page
    System.Gadget.settingsUI = "settings.html";
            
    refreshSettings();
}

function FadeImageIn(image)
{
   var opac = image.filters.alpha.opacity;
   if(opac >= 250)
   {
       image.filters.alpha.opacity = 255;
       clearInterval(fadeInterval);
       return;
   }
   else
   {
       image.filters.alpha.opacity = (opac + 10);
   }
}

function FadeImageOut(image)
{
   var opac = image.filters.alpha.opacity;
   if(opac <= 0)
   {
       clearInterval(fadeInterval);
       image.filters.alpha.opacity = 0;
       return;
   }
   else
   {
       image.filters.alpha.opacity = (opac - 10);
   }
}

// Read gadget settings from the sidebar APIs, then refresh the layout accordingly.
function refreshSettings()
{
    clearInterval(updateInterval);
    //bShowItemCount = System.Gadget.Settings.read("showItemCount") || false;
    var version = ReadVersionKey();
    if (parseFloat(version) > 3)
    {
        bSupportsIndexNow = true;
    }
    CheckBackoffKey();
    if(System.Gadget.Settings.read("backgroundColor"))
        strBackground = System.Gadget.Settings.read("backgroundColor");
    if(System.Gadget.Settings.read("textColor"))
        strTextColor = System.Gadget.Settings.read("textColor");
    document.body.style.color = strTextColor;
    refreshLayout();
}

// This function is called when the gadget is created, when it is moved on or off of the sidebar,
// and after settings have been changed.
function refreshLayout()
{
    document.body.style.height = '75px';
    document.body.style.width = '130px';
    divPendingUrlCount.style.width = '130px';
    divPendingUrlCount.style.left = '23px';
    divItemCount.style.left = '23px';
    divItemCount.style.width = '130px'; 
    divIndexerControls.style.left = '10px';
    vertDivider.style.margin = '0,4px,0,0px';
    imgShield.style.margin = '0,4px,0,0px';
    System.Gadget.background = 'images/background-' + strBackground + '-75.png';
    if (!bSupportsIndexNow)
    {
        imgFastForward.style.display = 'none';
    }
   
    // Trigger the main loop.
    Update();
    updateInterval=setInterval('Update();', 2000);
}


// Update() checks for the indexer's current status and updates the display accordingly.  
// It loops on a 2 second interval.
function Update()
{
    try
    {    
        // Get the count of items remaining to be processed.
        var count = HelperControl.GetPendingCount();
               
        // Figure out the indexer's current state.
        if(HelperControl.IsIndexerPaused())
        {
            divPendingUrlCount.innerText = "Indexer paused";
            bIndexerPaused = true;
            bIndexerDisabled = false;
        }
        else if(count == 0)
        {
            divPendingUrlCount.innerText = "Index up-to-date";
            bIndexerDisabled = false;
            bIndexerPaused = false;
        }
        else if(count == -1)
        {
            divPendingUrlCount.innerText = "Indexer stopped";
            bIndexerDisabled = true;
            bIndexerPaused = false;
        }
        else
        {
            divPendingUrlCount.innerText = "Indexing... [" + count + "]";
            bIndexerPaused = false;
            bIndexerDisabled = false;
        }
        // Update total item count
        var total = HelperControl.GetTotalItemsIndexed();
        if(total >= 0)
            divItemCount.innerText = total + " items total";
        else
            divItemCount.innerText = "";
            
        UpdateImages();  // Update the control buttons
    }
    catch(e)                                // An exception here should mean the indexer was stopped.
    {
        bIndexerDisabled = true;
        divPendingUrlCount.innerText = "Indexer stopped";
        divItemCount.innerText = "";
    }
}

// This function updates the indexer control buttons (pause/play/fast) to show which is pressed.
function UpdateImages()
{
    var PauseSrc = "images/pause.png";
    var PlaySrc = "images/play.png";
    var FastForwardSrc = "images/fastforward.png";
    if(bIndexerDisabled || bIndexerPaused)
        PauseSrc = "images/pausepushed.png";
    else
    {
        if(IsIndexNowPushed())
            FastForwardSrc = "images/fastforwardpushed.png";
        else
            PlaySrc = "images/playpushed.png";
    }
    imgPause.src = PauseSrc;
    imgPlay.src = PlaySrc;
    imgFastForward.src = FastForwardSrc;
}

function IsIndexNowPushed()
{
    if (!bSupportsIndexNow) {
        bIndexNowPushed = false;
    }
    else if (bIndexNowPushed && HelperControl.IsIndexerBackedOff() == true) {
        bIndexNowPushed = false;
    }
    return bIndexNowPushed;
}

function RunPauseScript()
{
    System.Shell.execute("wscript.exe", "\"" + System.Gadget.path + "\\vbs\\pause.vbs\"", "", "runas");
    // "runas" verb causes elevation prompt only if UAC is enabled or the user is not an admin.
}

function RunIndexWithBackoffScript()
{
    System.Shell.execute("wscript.exe", "\"" + System.Gadget.path + "\\vbs\\adaptive.vbs\"", "", "runas");
}

function RunIndexNowScript()
{
    System.Shell.execute("wscript.exe", "\"" + System.Gadget.path + "\\vbs\\indexnow.vbs\"", "", "runas");
}

function PauseIndexing()
{
    clearInterval(updateInterval);
    divPendingUrlCount.innerText = "Stopping Service";
    if(!bIsElevated)
        divItemCount.innerText = "Elevation required";
    else
        divItemCount.innerText = "";
    RunPauseScript();
    ChangedSpeed(true);
}
function IndexNormal()
{
    clearInterval(updateInterval);
    if(bIndexerDisabled)
    {
        divPendingUrlCount.innerText = "Starting Service...";
    }
    else
    {
        divPendingUrlCount.innerText = "Set speed (normal)";
    }
    if(!bIsElevated)
        divItemCount.innerText = "Elevation required";
    else
        divItemCount.innerText = "";
    RunIndexWithBackoffScript();
    bIndexNowPushed = false;
    bIndexerDisabled = false;
    ChangedSpeed(false);        
}

function IndexFast()
{
    clearInterval(updateInterval);
    if(bIndexerDisabled)
    {
        divPendingUrlCount.innerText = "Starting Service...";
    }
    else
    {
        divPendingUrlCount.innerText = "Set speed (fast)";
    }
    if(!bIsElevated)
        divItemCount.innerText = "Elevation required";
    else
        divItemCount.innerText = "";
    RunIndexNowScript();
    bIndexNowPushed = true;
    ChangedSpeed(false);
}

function ChangedSpeed(bIsPausing)
{
    if (bIsPausing == true)
    {
        setTimeout("updateInterval=setInterval('Update();', 2000);", 2000);
    }
    else
    {
        divPendingUrlCount.innerText = "Please wait...";
        divItemCount.innerText = "Restarting service";
        setTimeout("updateInterval=setInterval('Update();', 2000);", 8000);  // Give the indexer time to switch modes before we change our display text.
    }

    setTimeout("CheckBackoffKey();", 5000);
    setTimeout("CheckBackoffKey();", 10000);
    
    if(!bIsElevated)
    {
        setTimeout("clearInterval(fadeInterval);fadeInterval=setInterval('FadeImageOut(imgShield);', 20);", 1000);
    }
}

// Launches the indexer control panel.
function RunCPL()
{
    System.Shell.execute("rundll32.exe", "shell32.dll,Control_RunDLL \"srchadmin.dll\"");
}

function CheckBackoffKey()
{
    var wshShell;
    wshShell = new ActiveXObject("WScript.Shell");
    var value;
    try
    {
        value = wshShell.RegRead("HKLM\\SOFTWARE\\Policies\\Microsoft\\Windows\\Windows Search\\DisableBackoff");
    }
    catch (e)
    {
        value = 0;
    }
    bIndexNowPushed = value;
}

function ReadVersionKey()
{
    var wshShell;
    wshShell = new ActiveXObject("WScript.Shell");
    var value;
    try
    {
        value = wshShell.RegRead("HKLM\\SOFTWARE\\Microsoft\\Windows Search\\CurrentVersion");
    }
    catch (e)
    {
        value = 0;
    }
    return value;
}

// Registers a .NET 2.0 control just like RegAsm.exe does.
function regAsm(root, progId, cls, clsid, assembly, version, codebase)
{
    var wshShell;
    wshShell = new ActiveXObject("WScript.Shell"); 

    wshShell.RegWrite(root + "\\Software\\Classes\\" + progId + "\\", cls);
    wshShell.RegWrite(root + "\\Software\\Classes\\" + progId + "\\CLSID\\", clsid);
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\", cls); 

    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\", "mscoree.dll");
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\ThreadingModel", "Both");
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\Class", cls);
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\Assembly", assembly);
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\RuntimeVersion", "v2.0.50727");
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\CodeBase", codebase); 

    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Class", cls);
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\Assembly", assembly);
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\RuntimeVersion", "v2.0.50727");
    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\InprocServer32\\" + version + "\\CodeBase", codebase); 

    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\ProgId\\", progId); 

    wshShell.RegWrite(root + "\\Software\\Classes\\CLSID\\" + clsid + "\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "");
}